/* Copyright 2005-2008 Josh Clark and Global Moxie, LLC. All rights reserved.
   $Id: bm-build.js 3042 2008-03-31 13:56:04Z josh $
*/

BM.addLoadEvent( function() { //add post-validation callback to handle form
    $('bmBuildForm').onvalidate = function() {
      return BM.Build.submitForm('bmBuildForm', 'bmBuilderStatus');
    };
} );

BM.Build = {
    submitForm : function(form, container) {
        if ( !( form = $(form) ) ) return;
        if ( !( container = $(container) ) ) return;
        BM.Build.showBar(form,container);
        var showform = function() { BM.Build.showForm(form,container) };
        var url = form.action + '?' + Form.serialize(form);
        new BM.StatusDriver(container, url, {onfinish: showform});
        return false;
    },
    showBar : function(form,container) {
        BM.FX.hide( form.parentNode.parentNode );
        BM.FX.reveal(container.parentNode);
    },
    showForm : function(form,container) {
        BM.FX.hide(container.parentNode, {effect:'slide'});
        BM.FX.reveal(form.parentNode.parentNode, {effect:'slide'});
    }
};    
