/* bm-iemenu.js
$Id: bm-iemenu.js 1723 2007-02-27 11:45:12Z josh $

Overrides the default BM.Menu.init to help IE6 and earlier activate
the menus and display properly over select menu items.
The select/iframe fix is thanks to some nifty sleuthing by Tanny O'Haley:
http://tanny.ica.com/ica/tko/tkoblog.nsf/dx/select-tag-overlap-in-ie-part-iii
*/

//override the default BM.Menu.init (skip transparency; iframe makes it funky)
Object.extend(BM.Menu, {
    init : function(container) {
        var nav = $(container);
        if (!nav) return;
        var ieULs = nav.getElementsByTagName('ul');
        $A(ieULs).each(BM.Menu.updateIE);
        BM.Menu.updateIEli(nav);
    },
    updateIE : function(list) {
        //add iframe under each list
        var ieMat=document.createElement('iframe');
        if(document.location.protocol == "https:") ieMat.src="//0";
        else ieMat.src = "javascript:function(){return false;}";
        ieMat.scrolling = "no";
        ieMat.frameBorder = "0";
        ieMat.style.width = list.offsetWidth+"px";
        ieMat.style.height = list.offsetHeight+"px";
        ieMat.style.zIndex = "-1";
        list.insertBefore(ieMat, list.childNodes[0]);
        list.style.zIndex="101";
        Element.setOpacity(ieMat, 0);
    },
    updateIEli : function(list) {
        var ieLIs = list.getElementsByTagName('li');
        $A(ieLIs).each(function(li){
          Event.observe(li,'mouseover',function(){BM.FX.addClass(li,'iehover')});
          Event.observe(li,'mouseout',function(){BM.FX.removeClass(li,'iehover')});
        });
    }
});
